#ifndef INCLUDE_ALIAS_ENTITY_H
#define INCLUDE_ALIAS_ENTITY_H

#include "Entity.h"

class AliasEntity : public Entity {

 public:

  AliasEntity();
  ~AliasEntity();

  void setBody(char *);
  void setCommand(char *);
  void setMacroKey(int);
  void setMacroAlt(bool);
  void setMacroCtrl(bool);

  char * getBody();
  char * getCommand();
  int getMacroKey();
  bool getMacroAlt();
  bool getMacroCtrl();

  void save(FILE *);
  bool load(FILE *, char *);

  void execute(char *, char *);
  bool findExecute(EntityType, char *, char *, void *, bool);

  GtkWidget * getWidgets();
  void apply();

 private:

  int macro_key;
  bool macro_alt, macro_ctrl;
  char * body;
  char * command;


#ifdef USE_GTK_2
  GtkTextBuffer * description_buffer, * body_buffer;
#else
  GtkWidget * alias_description, * alias_body;
#endif

  GtkWidget * alias_command, * alias_shortcut, * alias_name;
  GtkWidget * alias_alt, * alias_ctrl;
  GtkWidget * option_menu;
  GtkWidget *table1;

};

#endif // INCLUDE_ALIAS_ENTITY_H
