#ifndef INCLUDE_ENTITY_GROUP_H
#define INCLUDE_ENTITY_GROUP_H

#include <list>
#include "Entity.h"

class EntityGroup : public Entity {

 public:

  EntityGroup();
  ~EntityGroup();

  void addEntity(Entity *);
  bool removeEntity(Entity *);

  bool findExecute(EntityType, char *, char *, void *, bool);

  void save(FILE *);
  bool load(FILE *, char *);

#ifdef USE_GTK_2
  void populate_tree_model(GtkTreeStore *, GtkTreeIter *);
#else
  void populate_tree(GtkWidget *);
#endif
  GtkWidget * getWidgets();

  Entity * findByID(int);

  void apply();
  void destroyWidgets();

  bool contains(Entity *);

  int count();

 private:

#ifdef IS_ENTITY_GROUP_C
  typedef std::list<Entity*> EntityList;
  std::list<Entity*> my_entities;
#endif

  GtkWidget * name_entry;
#ifdef USE_GTK_2
  GtkWidget * description_view;
  GtkTextBuffer * description_buffer;
#else
  GtkWidget * description_text;
#endif

};

#endif // INCLUDE_ENTITY_GROUP_H

