#ifndef INCLUDE_ENTITY_HANDLER_H
#define INCLUDE_ENTITY_HANDLER_H

#include "EntityGroup.h"

class EntityHandler {

 public:
  EntityHandler();
  ~EntityHandler();

  void addGroup(EntityGroup *);
  void removeGroup(EntityGroup *);
  void moveGroup(Entity *, char *);

  void addEntity(char * group, Entity *);
  void removeEntity(Entity *);
  void removeEntityGroup(EntityGroup *);

  EntityGroup * findGroup(char *, bool);

  void findExecute(EntityType type, char * field, char * value, void * data, bool multiple);

  void load();
  void save();

  void edit();

#ifdef USE_GTK_2
  void populate_tree_model(GtkTreeStore *);
  void row_selected(GtkTreeSelection *, gpointer);
#else
  void populate_tree(GtkWidget *);
#endif
  void apply();
  void close();

  void entitySelected(gpointer);

  Entity * findByID(int);

  void update();
  void selectEntity(Entity *);
  void deleteSelected();
  EntityGroup * getSelectedGroup();
  Entity * getSelectedEntity();
  int getSelectedID();

#ifdef USE_GTK_2
  void selectByID(GtkTreeIter *, gpointer);
#endif

  void newAlias();
  void newTrigger();

  GtkWidget * getGroupOptionMenu(Entity *);
  GList * getGroupOptionMenuList();
  
  EntityGroup * getEntityGroupForEntity(Entity *);
  
 private:

#ifdef USE_GTK
  GtkWidget * tree;
#endif
  
#ifdef ENTITY_HANDLER_C
  typedef std::list<EntityGroup*> GroupList;
  std::list<EntityGroup*> groups;
#endif

  GtkWidget * apply_button;
  GtkWidget * ok_button;
  GtkWidget * cancel_button;

  GtkWidget * window;
  GtkWidget * entity_widget;
  GtkWidget * vbox;

#ifdef USE_GTK_2
  GtkTreeStore * tree_model;
  GtkTreeSelection * selection;
  GtkWidget * tree_view;
#else
  GtkWidget * tree_widget;
#endif
};

#endif // INCLUDE_ENTITY_HANDLER_H

