#ifndef PLUGIN_H
#define PLUGIN_H

#include "Connection.h"
#include "Event.h"

class Plugin {
 public:

  Plugin();
  virtual ~Plugin();

  virtual void init(int argc, char * argv[]); // deprecated
  virtual void quit(void *); // deprecated

  virtual void input(Connection * c, char * in);
  virtual void output(Connection * c, char * in);
  virtual void prompt(Connection * c, char * in);
  virtual void clientMessage(Connection * c, char * in);

  virtual void onEvent(Event * e, Connection * c);

  virtual void pageSwitched(); // When the user changes pages in the GTKTwoWindow.

  virtual char * getDescription();

  char * getName() {return name;};
  float getVersion() {return version;};

  // Returns a GtkWidget to be put into the tabbed prefs notebook.
  virtual GtkWidget * getPrefsWidget(MUD *);
  virtual void onPrefsApply(MUD *);
  virtual void onPrefsOk(MUD *);
  virtual void savePrefs(FILE *, MUD *);
  virtual void onPrefsCancel(MUD *);

 protected:

  float version;
  char * name;
};

#endif
