#ifndef INCLUDE_TRIGGER_ENTITY_H
#define INCLUDE_TRIGGER_ENTITY_H

#include "Connection.h"
#include "Entity.h"

#include <regex.h>

typedef enum {
  TriggerSimple,
  TriggerRegex
} TriggerType;

class TriggerEntity : public Entity {

 public:

  TriggerEntity();
  ~TriggerEntity();

  void setMudName(char *);
  void setText(char *);
  void setTriggerType(TriggerType);
  void setBody(char *);

  char * getMudName();
  char * getText();
  TriggerType getTriggerType();
  char * getBody();

  void save(FILE *);
  bool load(FILE *, char *);

  void execute(Connection *, char *, char *);
  bool findExecute(EntityType, char *, char *, void *, bool);

  GtkWidget * getWidgets();

  void apply();

 private:

  void compile();

  char * mud;
  char * body;
  char * text;
  TriggerType trigger_type;

  GtkWidget *trigger_name;
  GtkWidget *trigger_text;
#ifdef USE_GTK_2
  GtkTextBuffer * trigger_description_buffer;
  GtkTextBuffer * trigger_body_buffer;
#else
  GtkWidget *trigger_description;
  GtkWidget *trigger_body;
#endif
  GtkWidget *trigger_options;
  GtkWidget *option_menu;

  regex_t regexp;
};

#endif // INCLUDE_TRIGGER_ENTITY_H
