#include "CommandInterpreter.h"
#include "EntityHandler.h"
#include "Connection.h"
#include "BaseWindow.h"
#include "PluginHandler.h"

void register_plugin(Plugin *, char *);
void unregister_plugin(Plugin *);

Socket * connection_get_socket(Connection *);
VT * connection_get_vt(Connection *);
char * connection_get_name(Connection *);
MUD * connection_get_mud(Connection *);
Connection * connection_get_next(Connection *);
Prefs * connection_query_preferences(Connection *);


int socket_write(Socket *, char *, int);

EvType event_get_type(Event *);

char * get_prefix();

void vt_add_to_tray(VT *, GtkWidget *, GtkWidget **);
void vt_remove_from_tray(VT *, GtkWidget *, GtkWidget *);
void vt_scroll(VT *);
void vt_append(VT *, char *);

char * preferences_get_preference(Prefs *, char *);
void preferences_set_preference(Prefs *, char *, char *);

void command_interpreter_interpret(CommandInterpreter *, Connection *, char *);

Prefs * get_global_preferences();
CommandInterpreter * get_command_interpreter();
Connection * get_first_connection();
EntityHandler * get_entity_handler();
BaseWindow * get_main_window();
PluginHandler * get_plugin_handler();
Connection * get_connection_by_name(char *);

void entity_handler_add_entity(EntityHandler *, char * group, Entity *);
void entity_handler_remove_entity(EntityHandler *, Entity *);

Connection * main_window_get_current_connection(BaseWindow *);
GtkItemFactory * main_window_get_item_factory(BaseWindow *);

void plugin_handler_client_message(PluginHandler *, Connection *, char *);

Prefs * mud_get_preferences(MUD *);

// Turf protocol uses void * to pass classes as dl.c won't accept C++ code.
extern "C" void turf_protocol_add_command(void *, char *, void *, gpointer);
extern "C" bool turf_protocol_is_supported(void *);
