#ifndef WIN32_PLUGIN_TABLE_H
#define WIN32_PLUGIN_TABLE_H

#ifdef WIN32

#include "CommandInterpreter.h"
#include "BaseWindow.h"
#include "EntityHandler.h"
#include "PluginHandler.h"

typedef void (*addr_register_plugin)(Plugin *, char *);
typedef void (*addr_unregister_plugin)(Plugin *);

typedef Socket * (*addr_connection_get_socket)(Connection *);
typedef VT * (*addr_connection_get_vt)(Connection *);
typedef MUD * (*addr_connection_get_mud)(Connection *);

typedef void (*addr_vt_append)(VT *, char *);
typedef void (*addr_vt_add_to_tray)(VT *, GtkWidget *, GtkWidget **);
typedef void (*addr_vt_remove_from_tray)(VT *, GtkWidget *, GtkWidget *);
typedef void (*addr_vt_scroll)(VT *);

typedef int (*addr_socket_write)(Socket *, char *, int);

typedef EvType (*addr_event_get_type)(Event *);

typedef char * (*addr_connection_get_name)(Connection *);
typedef Connection * (*addr_connection_get_next)(Connection *);
typedef Prefs * (*addr_connection_query_preferences)(Connection *);

typedef char * (*addr_get_prefix)();

typedef char * (*addr_preferences_get_preference)(Prefs *, char *);
typedef void (*addr_preferences_set_preference)(Prefs *, char *, char *);

typedef Prefs * (*addr_get_global_preferences)();
typedef Connection * (*addr_get_first_connection)();
typedef CommandInterpreter * (*addr_get_command_interpreter)();
typedef BaseWindow * (*addr_get_main_window)();
typedef PluginHandler * (*addr_get_plugin_handler)();
typedef EntityHandler * (*addr_get_entity_handler)();
typedef Connection * (*addr_get_connection_by_name)(char *);

typedef Connection * (*addr_main_window_get_current_connection)(BaseWindow *);
typedef GtkItemFactory * (*addr_main_window_get_item_factory)(BaseWindow *);

typedef void (*addr_entity_handler_add_entity)(EntityHandler *, char * group, Entity *);
typedef void (*addr_entity_handler_remove_entity)(EntityHandler *, Entity *);

typedef void (*addr_command_interpreter_interpret)(CommandInterpreter *, Connection *, char *);

typedef void (*addr_plugin_handler_client_message)(PluginHandler *, Connection *, char *);

typedef Prefs * (*addr_mud_get_preferences)(MUD *);

typedef void (*addr_turf_protocol_add_command)(void *, char *, void *, gpointer);
typedef bool (*addr_turf_protocol_is_supported)(void *);

typedef struct {
#include "Win32PluginAPIDecl.h"
} plugin_address_table_t;

#else

typedef void * plugin_address_table_t;

#endif

#endif // WIN32_PLUGIN_TABLE_H
