#ifndef WIN32

#include <gtk/gtk.h>
#ifndef WIN32
#include <gdk/gdkx.h>
#include <unistd.h>
#endif
#include <pthread.h>
#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
#include <string.h>

#include "mudclient.h"
#include "Prefs.h"
#include "PluginHandler.h"
#include "BaseWindow.h"
#include "Mudftp.h"
#include "version.h"

extern BaseWindow * mainWindow;
extern PluginHandler * phandler;
extern Prefs * globalPreferences;
static Mudftp * mudftp;

#define MAJOR "1"
#define MINOR "1"

extern "C" char * plugin_query_name() {
  return "Mudftp";
}

extern "C" char * plugin_query_description() {
  return "Embeds the gmudftp application into Papaya.";
}

extern "C" char * plugin_query_major() {
  return MAJOR;
}

extern "C" char * plugin_query_minor() {
  return MINOR;
}

extern "C" void plugin_init(void) {
  mudftp = new Mudftp();
}

extern "C" void plugin_cleanup(void) {
  delete mudftp;
}

Mudftp::Mudftp() {
  child_pid = 0;

  version = 1.0;
  name = strdup("mudFTP");
  phandler->registerPlugin(this, VERSION);

  if (globalPreferences->getMudftp())
    run();
}

Mudftp::~Mudftp() {
  // This is going to kill the main process!
  // kill();
  
  //  kill();
  phandler->unregisterPlugin(this);
}

void Mudftp::run() {
  char arg[1024];

  GtkWidget *socket = mainWindow->addPageForApp("mudFTP");

  sprintf(arg, "%ld", GDK_WINDOW_XWINDOW(socket->window));

  child_pid = fork();
  if (child_pid == 0) {
    execlp("gmudftp", arg, NULL);
    abort();
  }

  return;
}

void Mudftp::kill() {
  // @@ Kill process with child pid.
  ::kill(child_pid, SIGKILL);
}
#endif
char * Mudftp::getDescription() {
  return "Embeds gmudFTP into Papaya";
}




