#ifndef INCLUDE_PROMPT_PLUGIN_H
#define INCLUDE_PROMPT_PLUGIN_H

#include "Fade.h"
#define MAX_BARS 8


struct vtPrompt {

  int curr[MAX_BARS];
  int max[MAX_BARS];
  int bars;
  GtkWidget * widget;
  GtkWidget * frame;
  GtkWidget * event_box;
  Fade * fade;
  GtkTooltips * tooltips;

};

class PromptPlugin : public Plugin {

 public:

  PromptPlugin();
  ~PromptPlugin();

  void prompt(Connection *, char *);
  void onEvent(Event *, Connection *);
  GtkWidget * getPrefsWidget(MUD *);
  void onPrefsOk(MUD *);
  void onPrefsApply(MUD *);
  void onPrefsCancel(MUD *);

 private:
  vtPrompt prefs_scratch;

  char * findBar(char *, int *, int *);
  int convert(char *);
  int calculate(char *);
  struct vtPrompt * findPrompt(Connection *);
  struct vtPrompt * newPrompt(Connection *);
  void loadColours(struct vtPrompt *, MUD *);

};

#endif




