#include "version.h"
#include "PluginHandler.h"
#include "SamplePlugin.h"

extern PluginHandler * phandler;
static SamplePlugin * sample;

#define MAJOR "1"
#define MINOR "0"

extern "C" void plugin_init(void) {
  sample = new SamplePlugin();
}

extern "C" void plugin_cleanup(void) {
  delete sample;
}

extern "C" char * plugin_query_name() {
  return "SamplePlugin";
}

extern "C" char * plugin_query_description() {
  return "";
}

extern "C" char * plugin_query_major() {
  return MAJOR;
}

extern "C" char * plugin_query_minor() {
  return MINOR;
}

SamplePlugin::SamplePlugin() {
  version = 1.0;
  name = strdup("SamplePlugin");

  // This MUST be done after all variable initialisation as it can cause
  // onEvent(Event *, Connection *) to be called.
  phandler->registerPlugin(this, VERSION);
}

SamplePlugin::~SamplePlugin() {
  free(name);

  phandler->unregisterPlugin(this);
}
